package learning.bigdata.custom;

import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Partitioner;
import org.apache.hadoop.mapreduce.lib.partition.HashPartitioner;

/**
 * 
 * @author amar
 *
 */
public class KeyFieldsPartitioner extends Partitioner<Text, Text> {

	HashPartitioner<Text, Text> hashPartitioner = new HashPartitioner<Text, Text>();
	Text newKey = new Text();

	@Override
	public int getPartition(Text key, Text value, int numReduceTasks) {

		try {
			
			// Get the first field of the key
			String keyString = key.toString();
			String[] keyFields = keyString.split("-");
			newKey.set(keyFields[0]);

			// Execute the default partitioner over the first field of the key
			return hashPartitioner.getPartition(newKey, value, numReduceTasks);
		} catch (Exception e) {
			e.printStackTrace();
			return (int) (Math.random() * numReduceTasks); // this would return a random value in the range
															// [0,numReduceTasks)
		}
	}
}
