#!/usr/bin/python

import sys

key = None
currentKey = None
currentCount = 0

# In hadoop streaming, the output from mapper is received by reducer as input from STDIN
for line in sys.stdin:
    
    # trim the input line of any whitespaces
    line = line.strip()

    key, count = line.split('\t', 1)

    try:
        count = int(count)
    except ValueError:
        continue

    # Since all the keys are sorted before it is passed to the reducer, 
    # we can count till we find a different key
    if currentKey == key:
        currentCount += count
    else:
        if currentKey:
            # Results are emitted to STDOUT
            print '%s,%s' % (currentKey, currentCount)
        currentCount = count
        currentKey = key

# This section makes sure that the last key is also emitted
if currentKey == key:
    print '%s,%s' % (currentKey, currentCount)